######################################
# Job Definitions | Contract-Service #
######################################

# Template applied to all jobs concerning contract-service
---
.contract-service:template:
  artifacts:
    reports:
      junit:
        - services/contract-service/build/test-results/**/TEST-*.xml
    paths:
      - services/contract-service/build
      - image_references/*
    expire_in: 1 day
  before_script:
    - |
      #!/usr/bin/env sh
      cd services/contract-service || exit 1
      cp -r "$CI_PROJECT_DIR/.m2" ~/.m2 || echo "Local Maven Repositories not found"
  # Cache all gradle caches between jobs to speed up building and testing
  cache:
    key:
      files:
        - services/contract-service/build.gradle.kts
        - services/contract-service/settings.gradle.kts
    paths:
      - .gradle/caches
      - services/contract-service/.gradle
  variables:
    DEFAULT_NAMESPACE: base

# Build for e2e and main branch
contract-service:
  services:
    - name: docker:24.0.6-dind
      # Explicitly disable tls to avoid docker startup interruption
      command: ["--tls=false"]
  variables:
    DOCKER_HOST: "tcp://docker:2375"
    DOCKER_TLS_CERTDIR: ""
    DOCKER_DRIVER: overlay2
  extends:
    - .contract-service:template
    - .build:template
  needs: []
  script:
    - |
      #!/usr/bin/env sh
      echo "$CI_COMMIT_MESSAGE" | grep -Fq '[info]' && INFO='--info'
    - echo "Using image tag $IMG_TAG"
    - echo "Using image registry name $IMG_REGISTRY_NAME"
    - |
      gradle $INFO build -Dquarkus.container-image.username="$IMG_REGISTRY_USERNAME" \
        -Dquarkus.container-image.password="$IMG_REGISTRY_SECRET" \
        -Dquarkus.container-image.build=true \
        -Dquarkus.container-image.push=true \
        -Dquarkus.container-image.image="$IMG_REGISTRY_NAME/contract-service:$IMG_TAG" \
        -Dquarkus.jib.image-digest-file="$CI_PROJECT_DIR/img_digest_file"
    - mv build/reports/jacoco/test/jacoco.xml build/reports/jacoco/test/jacocoTestReport.xml
    - export IMAGE_REFERENCE_WITH_DIGEST
    - IMAGE_REFERENCE_WITH_DIGEST="$IMG_REGISTRY_NAME/contract-service:$IMG_TAG@$(cat "$CI_PROJECT_DIR"/img_digest_file)"
    - . "$CI_PROJECT_DIR/cluster/scripts/fail_if_image_not_present.sh" "$IMAGE_REFERENCE_WITH_DIGEST"
    - # shellcheck disable=SC1035
      !reference [".build:save-image-reference", "script"]
  rules:
    - if: $BUILD == "true"
  tags:
    - saas-linux-medium-amd64

# SonarScan
contract-service:sonarcloud:
  image: gradle:8.8-jdk17-alpine
  variables:
    SONAR_PROJECT_KEY: $SONARCLOUD_TEAM_IDENTIFIER-contract-service
    DIRECTORY: "contract-service"
  extends:
    - .contract-service:template
    - .sonarcloud:template
  needs:
    - contract-service
  rules:
    - if: $BUILD == "true"
